//			coefficient.C
//	unify the align subscript use to a*X+b uniform
//
//  written by Zheng Gengbin

/*
This pass change the align with subscript-use to a*X+b .
if the a or b can be caculated at compiling time , then caculate it .
*/

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#ifdef STDC_HEADERS
#include <stdlib.h>
#include <string.h>
#else
#include <strings.h>
#endif


#include "compilerApi.h"
#include "pass.h"

//extern "C" int strcasecmp(...);

SgExpression *AXB_tree(SgExpression *A,SgSymbol *s,SgExpression *B)
{
        SgExpression *t1;
        if (!A && !B) return NULL;
        if (A == NULL) t1=NULL;
        else {
                SgExpression *X=new SgExpression(VAR_REF,NULL,NULL,s,s->type());

                t1=new SgExpression(MULT_OP,A,X,NULL,s->type());
        }
        if (B==NULL)
                return t1;
        else
                if (t1==NULL)
                        return B;
                else
                        return new SgExpression(ADD_OP,t1,B,NULL,s->type());
}

/*
moved to fromsagexx.cc

SgExpression *AB_tree(SgExpression *A,SgExpression *B)
{
	return new SgExpression(EXPR_LIST,A,B,NULL);
}

                |
	+---------------+
	|		|
	A		B

SgExpression *coefficient(SgExpression *expr, SgSymbol *s)
{
	SgExpression *A=NULL,*B=NULL,*r1=NULL,*r2=NULL;
	SgExpression *a1=NULL,*a2=NULL,*b1=NULL,*b2=NULL;
	SgExpression *lp , *rp;

	switch (expr->variant() )
	{
	case INTRIN_FUNC_CALL :
		B=expr->copyPtr();
		return AB_tree(A,B);
	}

	lp = expr->lhs();
	rp = expr->rhs();
	if (lp) r1=coefficient(lp,s);
	if (rp) r2=coefficient(rp,s);

	if (r1) 
	{
		a1=r1->lhs();
		b1=r1->rhs();
	}

	if (r2)
	{
		a2=r2->lhs();
		b2=r2->rhs();
	}

	if (!lp & !rp) {
		int is_dummy = 0;
		if (expr->variant() == VAR_REF) {
			SgSymbol *sym = expr->symbol();
			if (!strcasecmp(s->identifier(),sym->identifier()))
				   is_dummy =1;
		}  
		if (is_dummy) {
			A=new SgExpression(INT_VAL,NULL,NULL,NULL,SgTypeInt());
			A->thellnd->entry.ival = 1;
		}
		else
			B=expr->copyPtr();
		return AB_tree(A,B);
	}

	//  unary operator
	if (lp && !rp) {	
		if (a1)  A=new SgExpression(expr->variant(),a1,NULL,NULL);
		if (b1)  B=new SgExpression(expr->variant(),b1,NULL,NULL);
		return AB_tree(A,B);
	}

	switch (expr->variant()) {
	case ADD_OP:
	case MINUS_OP:
		if (a1 && a2)           //  a1X + b1  +(-)  a2X + b2 
			A = new SgExpression(expr->variant(),a1,a2,NULL);
		else if (a1 || a2)
			{
				A = a1 ? a1 : a2;
				if (expr->variant()==MINUS_OP && !a1)
					A = new SgExpression(expr->variant(),A,NULL,NULL);
				else
					A=A->copyPtr();
			}
		if (b1 && b2) 
			B = new SgExpression(expr->variant(),b1,b2,NULL);
                else if (b1 || b2)
			{
                        	B = b1 ? b1 : b2;
				if (expr->variant()==MINUS_OP && !b1)
					B = new SgExpression(expr->variant(),B,NULL,NULL);
				else
					B=B->copyPtr();
			}
		break;
	case MULT_OP:
		if ( a1 && a2) {
			printf("Abormal coefficient. \n");
			exit (1);
		}
		if (a1) {     //   (a1X + b1) *  b2 
			if (b2)
				A = new SgExpression(MULT_OP,a1,b2,NULL);
			if (b1 && b2)
				B = new SgExpression(MULT_OP,b1,b2,NULL);
		}
		if (a2) {    //    b1 *  (a2X + b2)    
			if (b1)
				A = new SgExpression(MULT_OP,b1,a2,NULL);
                        if (b1 && b2)
				B = new SgExpression(MULT_OP,b1,b2,NULL);
		}
		if (!a1 && !a2) {  //   b1 * b2 
			if (b1 && b2)  
				B = new SgExpression(MULT_OP,b1,b2,NULL);
		}
		break;
	case DIV_OP:
		if ( a1 || a2 ) {
			printf("Abormal coefficient. \n");
			exit (1);
		}
		if (b1 && b2)    //    b1 / b2   
			B = new SgExpression(DIV_OP,b1,b2,NULL);
		break;
	}  

	return AB_tree(A,B);
}

*/

void align_coef(SgStatement *s)
{
	SgExpression *align_op,*align_dummy,*align_with;

	align_op = s->expr(2)->lhs();
	align_dummy=align_op->lhs();
        align_with=align_op->rhs()->rhs()->lhs();

	for (; align_with ; align_with=align_with->rhs())
	{
		SgExpression *with=align_with->lhs();

		for (SgExpression *dummy=align_dummy ; dummy ; dummy=dummy->rhs())
		{
			SgSymbol *dumsym=dummy->lhs()->symbol();
			if (with->IsSymbolInExpression(*dumsym) )
			{
				SgExpression *exp=coefficient(with,dumsym);
				// do some calculator so that the result is tidy
				int val;
				SgExpression *A=exp->lhs();
				A=calculateExp(A);
				SgExpression *B=exp->rhs();
				if (B==NULL)
					B=new SgValueExp(0);
				B=calculateExp(B);
				align_with->setLhs(AXB_tree(A,dumsym,B));
				break;
			}
		}
	}
}
